


    proc ReadPGRISRegister {Addr}  {
        global errorCode errorInfo
        global MIDAS_XPGRISAccessServer_Exists

# InsertLog "Get Addr=[format \"0x%x\" $Addr]"
# return 0

        if {[info exists MIDAS_XPGRISAccessServer_Exists]} {
# InsertLog "ReadPGRISRegister ::urn:XPGRISAccessServer do_Get"
            set rc [catch {interp eval "" ::namespace inscope ::urn:XPGRISAccessServer do_Get $Addr} m]
        } else {
# InsertLog "ReadPGRISRegister   XPGRISAccessClient__Get"
            set rc [catch {XPGRISAccessClient__Get $Addr} m]
        }
        if {$rc != 0} {
            InsertLog "ReadPGRISRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }

    proc WritePGRISRegister {Addr Vl}  {
        global errorCode errorInfo
        global MIDAS_XPGRISAccessServer_Exists

# InsertLog "Set $Vl => Addr=[format \"0x%x\" $Addr]"
# return 0

        if {[info exists MIDAS_XPGRISAccessServer_Exists]} {
# InsertLog "WritePGRISRegister ::urn:XPGRISAccessServer  do_Set"
            set rc [catch {interp eval "" ::namespace inscope ::urn:XPGRISAccessServer do_Set $Addr $Vl} m]
        } else {
# puts "WritePGRISRegister XPGRISAccessClient__Set"
            set rc [catch {XPGRISAccessClient__Set $Addr $Vl} m]
        }
        if {$rc != 0} {
            InsertLog "WritePGRISRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }


 proc DBSetValue {name value} {
       variable PROJECT
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode
        variable ::[set PROJECT]::DBRootName
        variable ::[set PROJECT]::DBNodeBase
        variable ::[set PROJECT]::DBNodeName

        set RootName $::[set PROJECT]::DBRootName
        set NodeBase $::[set PROJECT]::DBNodeBase
        set NodeName $::[set PROJECT]::DBNodeName

       set Path [set RootName]/[set NodeBase]/[set NodeName]

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_set $Path $name $value int} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                if {$name == "NULL"} then {
                    InsertLog "$Path created"
                } else {
                    if {$LogFlag == 1} {InsertLog "$Path: $name set to $value"}
                }
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $name NOT set: error [second $m]; [third $m]"
            }
        }
  }

  proc DBGetValue {name} {
       variable PROJECT
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode

        variable ::[set PROJECT]::DBRootName
        variable ::[set PROJECT]::DBNodeBase
        variable ::[set PROJECT]::DBNodeName

        set rc1 [catch {set RootName [set ::[set PROJECT]::DBRootName]} m]
        set rc2 [catch {set NodeBase [set ::[set PROJECT]::DBNodeBase]} m]
        set rc3 [catch {set NodeName [set ::[set PROJECT]::DBNodeName]} m]

        if {[expr $rc1+$rc2+$rc3] != 0} {InsertLog "DBGetValue error: $rc1 $rc2 $rc3"}

        set Path [set RootName]/[set NodeBase]/[set NodeName]

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_get $Path $name} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
            set value "Error!"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                if {$LogFlag == 1} {InsertLog "$Path: $name = $m"}
                set value "$m"
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $name NOT available: error [second $m]; [third $m]"
                set value "Error!"
            }
        }
        return $value
  }

  proc DBCreateNode {Path} {
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_set $Path NULL NULL NULL} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
               InsertLog "$Path created"
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path NOT created: error [second $m]; [third $m]"
            }
        }
  }

    proc DBGetNodes {Path Pattern} {
       variable LogFlag
        global errorCode errorInfo
        global MIDAS_DataBaseCode

        set nodeList {}

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_nodes $Path $Pattern} m]
        if {$rc != 0} {
            InsertLog "nodes returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode >= 0} then {
                if {$MIDAS_DataBaseCode == 0} then {
                     if {$LogFlag == 1} {InsertLog "$Path contains nodes"}
                     set nodeList {}
                     foreach item $m {
                         lappend nodeList $item
                         if {$LogFlag == 1} {InsertLog "$item"}
                     }
                } else {
                     if {$LogFlag == 1} {InsertLog "$Path contains no nodes"}
                }
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path access error: error [second $m]; [third $m]"
            }
        }
        return $nodeList
    }


