
    variable LogFlag 0

    proc InsertLog {s} {puts "$s"}


    variable PROJECT $::DataAcquisition::PROJECT
    variable OptionSet "Global"


   proc LoadOptions {} {
      variable PROJECT
      variable OptionSet

      set NodeBase [set ::[set PROJECT]::DBNodeBase]
      set ::[set PROJECT]::DBNodeBase "Options"

      set NodeName [set ::[set PROJECT]::DBNodeName]
      set ::[set PROJECT]::DBNodeName $OptionSet

      catch {unset ::Options}

      foreach item [split [DBGetValue Index] &&] {
         if {$item == ""} {continue}
         if {$item == "Index"} {continue}
         if {$item == "Error!"} {continue}
         set vl [DBGetValue $item]
         if {$vl != "Error!"} {set ::Options($item) $vl}
      }

      set ::[set PROJECT]::DBNodeBase $NodeBase
      set ::[set PROJECT]::DBNodeName $NodeName
   }

   proc SaveOptions {} {
      variable PROJECT
      variable OptionSet

      set NodeBase [set ::[set PROJECT]::DBNodeBase]
      set ::[set PROJECT]::DBNodeBase "Options"

      set NodeName [set ::[set PROJECT]::DBNodeName]
      set ::[set PROJECT]::DBNodeName $OptionSet

      set OptionList ""
      foreach item [array names ::Options] {
         if {$item == "Index"} {continue}
         if {[string length $OptionList] > 0} {append OptionList "&&"}
         append OptionList "$item"
         DBSetValue "$item" [first [set ::Options($item)]]
      }
      DBSetValue Index $OptionList

      set ::[set PROJECT]::DBNodeBase $NodeBase
      set ::[set PROJECT]::DBNodeName $NodeName
   }

   proc ParameterRestore {} {
    
#        set rc [catch {::VMESaveRestore::do_Restore} m]
        puts "ParameterRestore returns rc=$rc $m"

   }

   proc ParameterSave {} {

#        set rc [catch {::VMESaveRestore::do_Save} m]
        puts "ParameterSave returns rc=$rc $m"

   }

   proc SpecSave {} {
      global env
      variable PROJECT

      InsertLog "Saving histograms"

      set f1 [file join $env(MIDASBASE) SpecData $PROJECT]
      set z [catch {file mkdir $f1} m]
      set f2 [file join $env(MIDASBASE) SpecData $PROJECT [date +%Y%h%d-%H.%M.%S]]
      set z [catch {file mkdir $f2} m]

      set SpecNames [SpectrumNames]
      set NumSpec 0
      foreach item $SpecNames {
         if {[first $item] != 1} {continue}   ;#   not a valid histogram !!
         set SpecName [second $item]
         set SpecTitle [SpectrumGetTitle $SpecName]
         set SpecDetails [SpectrumDetails $SpecName]

         set Dim  [first $SpecDetails]
         set Base [first [second $SpecDetails]]
         set Range [first [third $SpecDetails]]

         if {$Dim != 1} {continue}   ;#   not a 1D histogram

         set SpecData [SpectrumRead1D $SpecName $Base $Range]

         set z [catch {open [file join $f2 $SpecName] w} f]
         foreach item $SpecData {puts $f $item}
         close $f

         incr NumSpec
      }

      InsertLog "$NumSpec Histograms saved to $f2"
#      Elog INFORMATION "Histograms saved to $f2"

     return "$NumSpec Histograms saved to $f2"

   }



